/* gnome_break_timer_service.vapi generated by valac 0.21.2, do not modify. */

[CCode (cheader_filename = "gnome_break_timer_service.h")]
public abstract class BreakController : GLib.Object {
	public enum FinishedReason {
		DISABLED,
		SKIPPED,
		SATISFIED
	}
	public enum State {
		WAITING,
		ACTIVE,
		DISABLED
	}
	public BreakController ();
	public void activate ();
	public virtual void deserialize (ref Json.Object json_root);
	public void finish ();
	public int get_seconds_since_start ();
	public bool is_active ();
	public bool is_enabled ();
	public virtual Json.Object serialize ();
	public void set_enabled (bool enable);
	public void skip (bool forget_start = false);
	public BreakController.State state { get; private set; }
	public signal void activated ();
	public signal void active_changed ();
	public signal void disabled ();
	public signal void enabled ();
	public signal void finished (BreakController.FinishedReason reason, bool was_active);
	public signal void unwarned ();
	public signal void warned ();
}
[CCode (cheader_filename = "gnome_break_timer_service.h")]
public abstract class BreakType : GLib.Object {
	public BreakController break_controller;
	public BreakView break_view;
	public string id;
	protected GLib.Settings settings;
	public BreakType (string id, GLib.Settings settings);
	protected abstract BreakController get_break_controller ();
	protected abstract BreakView get_break_view (BreakController controller, UIManager ui_manager);
	public virtual void initialize (UIManager ui_manager);
}
[CCode (cheader_filename = "gnome_break_timer_service.h")]
public abstract class BreakView : UIManager.UIFragment {
	protected weak BreakController break_controller;
	public BreakView (BreakController break_controller, UIManager ui_manager);
	protected Notify.Notification build_common_notification (string summary, string? body, string? icon);
	protected virtual void dismiss_break ();
	protected override void focus_started ();
	protected override void focus_stopped ();
	public abstract string get_status_message ();
	protected int seconds_since_last_break_notification ();
	protected void show_break_info ();
	protected void show_break_notification (Notify.Notification notification);
	public signal void focused_and_activated ();
	public signal void lost_ui_focus ();
}
[CCode (cheader_filename = "gnome_break_timer_service.h")]
public abstract class TimerBreakController : BreakController {
	protected PausableTimeout countdowns_timeout;
	protected Countdown duration_countdown;
	protected int fuzzy_seconds;
	protected Countdown interval_countdown;
	public TimerBreakController (ActivityMonitor activity_monitor, int fuzzy_seconds = 0);
	public override void deserialize (ref Json.Object json_root);
	public int get_current_duration ();
	public int get_time_remaining ();
	public void postpone (int resume_after);
	public override Json.Object serialize ();
	public int starts_in ();
	public int duration { get; set; }
	public int interval { get; set; }
	public signal void counting (int lap_time, int total_time);
	public signal void delayed (int lap_time, int total_time);
}
[CCode (cheader_filename = "gnome_break_timer_service.h")]
public abstract class TimerBreakType : BreakType {
	public TimerBreakType (string id, GLib.Settings settings);
	protected override void initialize (UIManager ui_manager);
}
[CCode (cheader_filename = "gnome_break_timer_service.h")]
public class TimerBreakStatusWidget : Gtk.Grid, IScreenOverlayContent {
	public TimerBreakStatusWidget (TimerBreakController timer_break);
	public void set_message (string message);
}
[CCode (cheader_filename = "gnome_break_timer_service.h")]
public abstract class TimerBreakView : BreakView {
	public TimerBreakView (TimerBreakController timer_break, UIManager ui_manager);
	protected int get_lead_in_seconds ();
	public override string get_status_message ();
	protected TimerBreakController timer_break { get; }
}
[CCode (cheader_filename = "gnome_break_timer_service.h")]
public class MicroBreakController : TimerBreakController {
	public MicroBreakController (ActivityMonitor activity_monitor);
}
[CCode (cheader_filename = "gnome_break_timer_service.h")]
public class MicroBreakType : TimerBreakType {
	public MicroBreakType (ActivityMonitor activity_monitor);
	protected override BreakController get_break_controller ();
	protected override BreakView get_break_view (BreakController controller, UIManager ui_manager);
}
[CCode (cheader_filename = "gnome_break_timer_service.h")]
public class MicroBreakView : TimerBreakView {
	public MicroBreakView (MicroBreakController micro_break, UIManager ui_manager);
	protected new void show_break_notification (Notify.Notification notification);
	protected MicroBreakController micro_break { get; }
}
[CCode (cheader_filename = "gnome_break_timer_service.h")]
public class RestBreakController : TimerBreakController {
	public RestBreakController (ActivityMonitor activity_monitor);
	public override void deserialize (ref Json.Object json_root);
	public override Json.Object serialize ();
	public signal void current_duration_changed ();
}
[CCode (cheader_filename = "gnome_break_timer_service.h")]
public class RestBreakType : TimerBreakType {
	public RestBreakType (ActivityMonitor activity_monitor);
	protected override BreakController get_break_controller ();
	protected override BreakView get_break_view (BreakController controller, UIManager ui_manager);
}
[CCode (cheader_filename = "gnome_break_timer_service.h")]
public class RestBreakView : TimerBreakView {
	public RestBreakView (RestBreakController rest_break, UIManager ui_manager);
	protected override void dismiss_break ();
	protected new void show_break_notification (Notify.Notification notification, bool allow_postpone);
	protected RestBreakController rest_break { get; }
}
[CCode (cheader_filename = "gnome_break_timer_service.h")]
public class BreakManager : GLib.Object {
	public BreakManager (UIManager ui_manager);
	public Gee.Set<string> all_break_ids ();
	public Gee.Collection<BreakType> all_breaks ();
	public void deserialize (ref Json.Object json_root);
	public BreakType? get_break_type_for_name (string name);
	public void load_breaks (ActivityMonitor activity_monitor);
	public Json.Object serialize ();
	public bool master_enabled { get; set; }
	public string[] selected_break_ids { get; set; }
}
[CCode (cheader_filename = "gnome_break_timer_service.h")]
[DBus (name = "org.gnome.BreakTimer")]
public class BreakHelperServer : GLib.Object, IBreakHelper {
	public BreakHelperServer (BreakManager break_manager);
	public bool is_active ();
}
[CCode (cheader_filename = "gnome_break_timer_service.h")]
public class HelperApplication : Gtk.Application {
	public HelperApplication ();
	public override void activate ();
	public override void shutdown ();
	public override void startup ();
}
[CCode (cheader_filename = "gnome_break_timer_service.h")]
public class ScreenOverlay : Gtk.Window {
	public enum Format {
		SILENT,
		MINI,
		FULL
	}
	public ScreenOverlay ();
	public void disappear_content (IScreenOverlayContent? widget);
	public void fade_in ();
	public void fade_out ();
	public bool is_showing_content (IScreenOverlayContent? widget);
	public void request_attention ();
	public void reveal_content (IScreenOverlayContent? widget);
	public void set_content (IScreenOverlayContent? widget);
	public void set_format (ScreenOverlay.Format format);
	public void shake ();
}
[CCode (cheader_filename = "gnome_break_timer_service.h")]
public class SessionStatus : ISessionStatus, GLib.Object {
	public SessionStatus (Gtk.Application application);
}
[CCode (cheader_filename = "gnome_break_timer_service.h")]
public class UIManager : SimpleFocusManager {
	public abstract class UIFragment : GLib.Object, IFocusable {
		protected FocusPriority focus_priority;
		protected Notify.Notification? notification;
		protected IScreenOverlayContent? overlay_content;
		protected UIManager ui_manager;
		public UIFragment ();
		protected bool can_lock_screen ();
		protected abstract void focus_started ();
		protected abstract void focus_stopped ();
		public bool has_ui_focus ();
		protected void hide_notification ();
		protected void hide_overlay ();
		protected void lock_screen ();
		protected bool notifications_can_do (string capability);
		protected bool overlay_is_visible ();
		protected void play_sound_from_id (string event_id);
		protected void release_ui_focus ();
		protected void request_ui_focus ();
		protected void reveal_overlay ();
		protected void set_overlay (IScreenOverlayContent overlay_content);
		protected void shake_overlay ();
		protected void show_lock_notification (Notify.Notification notification);
		protected void show_notification (Notify.Notification notification);
	}
	protected Notify.Notification? notification;
	protected weak GLib.List<string> notify_capabilities;
	protected ScreenOverlay? screen_overlay;
	public UIManager (Gtk.Application application, ISessionStatus session_status, bool with_overlay);
	public void add_break (BreakView break_view);
	protected void hide_notification (Notify.Notification? notification, bool immediate = true);
	public void remove_break (BreakView break_view);
	protected void show_lock_notification (Notify.Notification notification);
	protected void show_notification (Notify.Notification notification);
	public bool quiet_mode { get; set; }
	public int64 quiet_mode_expire_time { get; set; }
}
[CCode (cheader_filename = "gnome_break_timer_service.h")]
public interface IScreenOverlayContent : Gtk.Widget {
	public abstract void added_to_overlay ();
	public abstract void before_fade_in ();
	public abstract void before_fade_out ();
	public abstract void removed_from_overlay ();
}
[CCode (cheader_filename = "gnome_break_timer_service.h")]
[DBus (name = "org.gnome.ScreenSaver")]
public interface IScreenSaver : GLib.Object {
	public abstract bool get_active () throws GLib.IOError;
	public abstract uint32 get_active_time () throws GLib.IOError;
	public abstract void @lock () throws GLib.IOError;
	public abstract void set_active (bool active) throws GLib.IOError;
	public signal void active_changed (bool active);
}
